﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Data.SqlClient;
using System.Text;
using System.Threading.Tasks;

namespace awt
{
    class Program
    {
        static void Main(string[] args)
        {
            MainAsync();
        }
        static async Task MainAsync()
        {
            await callTweet();
        }

        private static async Task callTweet()
        {
            tweetWxData();
            for (int i = 10; i >= 0; i--) {
                System.Threading.Thread.Sleep(1000);
                Console.Write(i.ToString() + "...");
            }
        }

        private static async Task tweetWxData()
        {
            try
            {
                string ConsumerKey = "<enter yours here>";
                string ConsumerKeySecret = "<enter yours here>";
                string AccessToken = "<enter yours here>";
                string AccessTokenSecret = "<enter yours here>";
                var twitter = new TwitterApi(ConsumerKey, ConsumerKeySecret, AccessToken, AccessTokenSecret);
                string getTemp = getCurrentAWTemperature();
                var response = await twitter.Tweet(getTemp);
                Console.WriteLine(response);
            }
            catch(Exception ex)
            {
                string msg = ex.Message;
            }
        }

        private static string getCurrentAWTemperature()
        {
            string ret = "";
            string lastMeasurementDateTime = "";
            string lastOutsideTemperature = "";
            string bp = "";
            string lastIndoorTemperature = "";
            string windSpeed = "";
            string sql = "exec [stage].[GrabLatestAWReading]";
            try
            {
                using (SqlConnection cn = new SqlConnection("<enter yours here>"))
                {
                    cn.Open();
                    SqlCommand cmd = new SqlCommand(sql, cn);
                    SqlDataReader rdr = cmd.ExecuteReader();
                    while (rdr.Read())
                    {
                        lastMeasurementDateTime = rdr[0].ToString() + " ET";
                        lastOutsideTemperature = rdr[1].ToString();
                        lastIndoorTemperature = rdr[12].ToString();
                        bp = Convert.ToInt32((Convert.ToDouble(rdr[6]) * 33.8639)).ToString();
                        windSpeed = rdr[8].ToString();
                    }
                    // construct your message here
                    string msg = @"The temperature in Andy's office is {2}°F.
Measurements at Hampden-Sydney Virginia at {0}:
Temperature* {1}°F.
Barometric Pressure*: {3} mb
Wind Speed*: {4} m/s
*Accuracy subject to instrument connectivity";
                    ret = String.Format(msg, lastMeasurementDateTime, lastOutsideTemperature, lastIndoorTemperature, bp, windSpeed);
                }
                return ret;
            }
            catch (Exception ex)
            {
                throw;
                // do nothing for now...
            }
        }
    }
}
